package bip.gwm.scm.settlement.test;

import cn.hutool.core.codec.Base64Decoder;
import cn.hutool.crypto.SmUtil;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.math.BigInteger;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.MessageDigest;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;
import java.security.cert.X509Certificate;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Date;
import java.util.Enumeration;
import java.util.concurrent.TimeUnit;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import okhttp3.Request.Builder;
import org.bouncycastle.asn1.ASN1EncodableVector;
import org.bouncycastle.asn1.ASN1InputStream;
import org.bouncycastle.asn1.ASN1Integer;
import org.bouncycastle.asn1.ASN1Sequence;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.gm.GMNamedCurves;
import org.bouncycastle.asn1.x9.X9ECParameters;
import org.bouncycastle.crypto.digests.SM3Digest;
import org.bouncycastle.crypto.params.ECDomainParameters;
import org.bouncycastle.crypto.params.ECPrivateKeyParameters;
import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.bouncycastle.crypto.params.ParametersWithID;
import org.bouncycastle.crypto.signers.SM2Signer;
import org.bouncycastle.jcajce.provider.asymmetric.ec.BCECPublicKey;
import org.bouncycastle.jce.ECNamedCurveTable;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.jce.spec.ECNamedCurveParameterSpec;
import org.bouncycastle.jce.spec.ECParameterSpec;
import org.bouncycastle.jce.spec.ECPublicKeySpec;
import org.bouncycastle.math.ec.ECPoint;
import org.bouncycastle.util.encoders.Hex;

public class Asymmetric {

   private static X9ECParameters x9ECParameters = GMNamedCurves.getByName("sm2p256v1");
   private static ECDomainParameters ecDomainParameters = new ECDomainParameters(x9ECParameters.getCurve(), x9ECParameters.getG(), x9ECParameters.getN());
   private static ECParameterSpec ecParameterSpec = new ECParameterSpec(x9ECParameters.getCurve(), x9ECParameters.getG(), x9ECParameters.getN());


   public static void main(String[] args) throws Exception {
   }

   public static void test() {
      try {
         String e = "${替换为您的私钥}";
         String appid = "${替换为您在Open API中创建的应用的appid}";
         String appsecret = "${替换为您在Open API中创建的应用的appsecret}";
         String url = "${替换为您要调用的接口地址，格式形如http://ip:port/testpath/api}";
         String verify = "SM3withSM2";
         String timestamp = String.valueOf((new Date()).getTime() / 1000L);
         String bodyString = "{\"environment\":\"test\",\"operation\":\"check\"}";
         String sign = sm3Signature2(bodyString);
         ArrayList list = new ArrayList();
         list.add("appid=" + appid);
         list.add("secret=" + appsecret);
         list.add("sign=" + sign);
         list.add("timestamp=" + timestamp);
         String src = String.join("&", list);
         byte body = -1;
         switch(verify.hashCode()) {
         case -1650292320:
            if(verify.equals("SHA256Verify")) {
               body = 0;
            }
            break;
         case -1354961460:
            if(verify.equals("SHA256withRSAVerify")) {
               body = 2;
            }
            break;
         case -821652647:
            if(verify.equals("SM3withSM2")) {
               body = 3;
            }
            break;
         case -146384048:
            if(verify.equals("HmacMd5Verify")) {
               body = 1;
            }
         }

         String apisign;
         switch(body) {
         case 0:
            apisign = sha256Signature(src);
            break;
         case 1:
            apisign = hmacSignature(appsecret, src);
            break;
         case 2:
            apisign = sha256withRSASignature(e, src);
            break;
         case 3:
            apisign = sm3withsm2Signature2(e, src);
            break;
         default:
            throw new RuntimeException("未知签名方式");
         }

         System.out.println("APIsign:" + apisign);
         MediaType JSON = MediaType.parse("application/json; charset=utf-8");
         RequestBody body1 = RequestBody.create(JSON, bodyString);
         Request request = (new Builder()).url(url).post(body1).addHeader("appid", appid).addHeader("timestamp", timestamp).addHeader("sign", sign).addHeader("apisign", apisign).addHeader("verify", verify).build();
         Response response = getClient().newCall(request).execute();
         System.out.println("请求是否成功：" + response.isSuccessful());
         System.out.println(response.body().string());
         response.close();
      } catch (Exception var15) {
         var15.printStackTrace();
      }

   }

   public static String toHexString(byte[] byteArray) {
      StringBuilder hexString = new StringBuilder("");
      if(byteArray != null && byteArray.length > 0) {
         for(int i = 0; i < byteArray.length; ++i) {
            int v = byteArray[i] & 255;
            String hv = Integer.toHexString(v);
            if(hv.length() < 2) {
               hexString.append('0');
            }

            hexString.append(hv);
         }

         return hexString.toString().toLowerCase();
      } else {
         return null;
      }
   }

   public static String sha256withRSASignature(String privateKeyStr, String dataStr) {
      try {
         byte[] e = Base64.getDecoder().decode(privateKeyStr);
         byte[] data = dataStr.getBytes();
         PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(e);
         KeyFactory keyFactory = KeyFactory.getInstance("RSA");
         PrivateKey privateKey = keyFactory.generatePrivate(keySpec);
         Signature signature = Signature.getInstance("SHA256withRSA");
         signature.initSign(privateKey);
         signature.update(data);
         return new String(Base64.getEncoder().encode(signature.sign()));
      } catch (Exception var8) {
         throw new RuntimeException("签名计算出现异常");
      }
   }

   public static String sm3withsm2Signature2(String privateKeyStr, String dataStr) throws Exception {
      byte[] key = Hex.decode(privateKeyStr);
      byte[] data = dataStr.getBytes();
      ECNamedCurveParameterSpec spec = ECNamedCurveTable.getParameterSpec("sm2p256v1");
      ECDomainParameters domainParameters = new ECDomainParameters(spec.getCurve(), spec.getG(), spec.getN(), spec.getH(), spec.getSeed());
      ECPrivateKeyParameters privateKey = new ECPrivateKeyParameters(new BigInteger(1, key), domainParameters);
      ParametersWithID parameters = new ParametersWithID(privateKey, "1234567812345678".getBytes());
      SM2Signer signer = new SM2Signer();
      signer.init(true, parameters);
      signer.update(data, 0, data.length);
      byte[] signature = decodeDERSignature(signer.generateSignature());
      return Hex.toHexString(signature);
   }

   public static void initKey() throws Exception {
      KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance("RSA");
      keyPairGenerator.initialize(2048);
      KeyPair keyPair = keyPairGenerator.generateKeyPair();
      RSAPublicKey publicKey = (RSAPublicKey)keyPair.getPublic();
      RSAPrivateKey privateKey = (RSAPrivateKey)keyPair.getPrivate();
      System.out.println("public key is: " + new String(Base64.getEncoder().encode(publicKey.getEncoded())));
      System.out.println("private key is: " + new String(Base64.getEncoder().encode(privateKey.getEncoded())));
   }

   public static void apiSignVerify(String publicKeyStr, String msgStr, String signatureStr) throws Exception {
      byte[] pubkey = Hex.decode(publicKeyStr);
      byte[] msg = msgStr.getBytes();
      byte[] signature = Hex.decode(signatureStr);
      verify((byte[])pubkey, (byte[])msg, (byte[])signature);
   }

   public static void verify(String publicKeyStr, String msgStr, String signatureStr) throws Exception {
      byte[] pubkey = Hex.decode(publicKeyStr);
      byte[] msg = msgStr.getBytes();
      byte[] signature = SmUtil.rsAsn1ToPlain(Base64Decoder.decode(signatureStr));
      verify((byte[])pubkey, (byte[])msg, (byte[])signature);
   }

   public static boolean rsaVerify(String dataStr, String publicKeyStr, String signStr) throws Exception {
      KeyFactory keyFactory = KeyFactory.getInstance("RSA");
      X509EncodedKeySpec x509EncodedKeySpec = new X509EncodedKeySpec(Base64.getDecoder().decode(publicKeyStr));
      PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
      Signature signature = Signature.getInstance("SHA256withRSA");
      signature.initVerify(publicKey);
      signature.update(dataStr.getBytes());
      return signature.verify(Base64.getDecoder().decode(signStr));
   }

   public static String sm3Signature2(String src) {
      try {
         SM3Digest e = new SM3Digest();
         e.update(src.getBytes("UTF-8"), 0, src.getBytes("UTF-8").length);
         byte[] ret = new byte[e.getDigestSize()];
         e.doFinal(ret, 0);
         return Hex.toHexString(ret);
      } catch (Exception var3) {
         throw new RuntimeException("签名计算出现异常");
      }
   }

   public static OkHttpClient getClient() {
      try {
         SSLContext e = SSLContext.getInstance("SSL");
         X509TrustManager x509TrustManager = new X509TrustManager() {
            public void checkClientTrusted(X509Certificate[] chain, String authType) {
            }
            public void checkServerTrusted(X509Certificate[] chain, String authType) {
            }
            public X509Certificate[] getAcceptedIssuers() {
               return new X509Certificate[0];
            }
         };
         TrustManager[] trustAllCerts = new TrustManager[]{x509TrustManager};
         e.init((KeyManager[])null, trustAllCerts, new SecureRandom());
         SSLSocketFactory sslSocketFactory = e.getSocketFactory();
         OkHttpClient client = (new okhttp3.OkHttpClient.Builder()).readTimeout(60L, TimeUnit.SECONDS).sslSocketFactory(sslSocketFactory, x509TrustManager).hostnameVerifier(new HostnameVerifier() {
            public boolean verify(String s, SSLSession sslSession) {
               return true;
            }
         }).build();
         return client;
      } catch (Exception var5) {
         throw new RuntimeException("Http客户端构造失败");
      }
   }

   public static String hmacSignature(String key, String data) {
      try {
         SecretKeySpec e = new SecretKeySpec(key.getBytes("UTF-8"), "HmacMD5");
         Mac mac = Mac.getInstance("HmacMD5");
         mac.init(e);
         byte[] resultBytes = mac.doFinal(data.getBytes("UTF-8"));
         String resultString = toHexString(resultBytes);
         return resultString;
      } catch (Exception var6) {
         throw new RuntimeException("签名计算出现异常");
      }
   }

   public static String sha256Signature(String src) {
      try {
         MessageDigest e = MessageDigest.getInstance("SHA-256");
         e.update(src.getBytes("UTF-8"));
         byte[] bytes = e.digest();
         return toHexString(bytes);
      } catch (Exception var3) {
         throw new RuntimeException("签名计算出现异常");
      }
   }

   public static void verify(byte[] pubkey, byte[] msg, byte[] signature) throws Exception {
      ECPublicKeyParameters publicKey = encodePublicKey(pubkey);
      SM2Signer signer = new SM2Signer();
      ParametersWithID parameters = new ParametersWithID(publicKey, "1234567812345678".getBytes());
      signer.init(false, parameters);
      signer.update(msg, 0, msg.length);
      System.out.println("verify:" + signer.verifySignature(encodeDERSignature(signature)));
   }

   private static byte[] encodeDERSignature(byte[] signature) throws Exception {
      byte[] r = new byte[32];
      byte[] s = new byte[32];
      System.arraycopy(signature, 0, r, 0, 32);
      System.arraycopy(signature, 32, s, 0, 32);
      ASN1EncodableVector vector = new ASN1EncodableVector();
      vector.add(new ASN1Integer(new BigInteger(1, r)));
      vector.add(new ASN1Integer(new BigInteger(1, s)));

      try {
         return (new DERSequence(vector)).getEncoded();
      } catch (IOException var5) {
         throw new Exception();
      }
   }

   private static ECPublicKeyParameters encodePublicKey(byte[] value) {
      byte[] x = new byte[32];
      byte[] y = new byte[32];
      System.arraycopy(value, 1, x, 0, 32);
      System.arraycopy(value, 33, y, 0, 32);
      BigInteger X = new BigInteger(1, x);
      BigInteger Y = new BigInteger(1, y);
      ECPoint Q = ECNamedCurveTable.getParameterSpec("sm2p256v1").getCurve().createPoint(X, Y);
      return new ECPublicKeyParameters(Q, getECDomainParameters());
   }

   private static ECDomainParameters getECDomainParameters() {
      ECNamedCurveParameterSpec spec = ECNamedCurveTable.getParameterSpec("sm2p256v1");
      return new ECDomainParameters(spec.getCurve(), spec.getG(), spec.getN(), spec.getH(), spec.getSeed());
   }

   private static byte[] decodeDERSignature(byte[] signature) throws Exception {
      ASN1InputStream stream = new ASN1InputStream(new ByteArrayInputStream(signature));

      try {
         ASN1Sequence var10 = (ASN1Sequence)stream.readObject();
         Enumeration enumeration = var10.getObjects();
         BigInteger R = ((ASN1Integer)enumeration.nextElement()).getValue();
         BigInteger S = ((ASN1Integer)enumeration.nextElement()).getValue();
         byte[] bytes = new byte[64];
         byte[] r = format(R.toByteArray());
         byte[] s = format(S.toByteArray());
         System.arraycopy(r, 0, bytes, 0, 32);
         System.arraycopy(s, 0, bytes, 32, 32);
         return bytes;
      } catch (Exception var9) {
         throw new Exception();
      }
   }

   private static byte[] format(byte[] value) {
      if(value.length == 32) {
         return value;
      } else {
         byte[] bytes = new byte[32];
         if(value.length > 32) {
            System.arraycopy(value, value.length - 32, bytes, 0, 32);
         } else {
            System.arraycopy(value, 0, bytes, 32 - value.length, value.length);
         }

         return bytes;
      }
   }

   public static BCECPublicKey getECPublicKeyByPublicKeyHex(String pubKeyHex) {
      if(pubKeyHex.length() > 128) {
         pubKeyHex = pubKeyHex.substring(pubKeyHex.length() - 128);
      }

      String stringX = pubKeyHex.substring(0, 64);
      String stringY = pubKeyHex.substring(stringX.length());
      BigInteger x = new BigInteger(stringX, 16);
      BigInteger y = new BigInteger(stringY, 16);
      ECPublicKeySpec ecPublicKeySpec = new ECPublicKeySpec(x9ECParameters.getCurve().createPoint(x, y), ecParameterSpec);
      return new BCECPublicKey("EC", ecPublicKeySpec, BouncyCastleProvider.CONFIGURATION);
   }

}
